import { ComponentOptionsMixin } from 'vue';
import { DefineComponent } from 'vue';
import { ExtractPropTypes } from 'vue';
import { PropType } from 'vue';
import { PublicProps } from 'vue';

declare type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;

declare type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};

declare type __VLS_TypePropsToOption<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: PropType<T[K]>;
        required: true;
    };
};

declare type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? __VLS_Prettify<P[K] & {
        default: D[K];
    }> : P[K];
};

export declare const AdminLayout: DefineComponent<__VLS_WithDefaults<__VLS_TypePropsToOption<LayoutProps>, {
mode: string;
headerHeight: number;
siderCollapse: boolean;
siderWidth: number;
siderCollapsedWidth: number;
footerHeight: number;
maxZIndex: number;
}>, {}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {}, string, PublicProps, Readonly<ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToOption<LayoutProps>, {
mode: string;
headerHeight: number;
siderCollapse: boolean;
siderWidth: number;
siderCollapsedWidth: number;
footerHeight: number;
maxZIndex: number;
}>>>, {
mode: LayoutMode;
maxZIndex: number;
headerHeight: number;
siderCollapse: boolean;
siderWidth: number;
siderCollapsedWidth: number;
footerHeight: number;
}, {}>;

declare interface ContentConfig {
    /**
     * 主体内容样式名
     * @default ''
     */
    contentClass?: string;
}

/**
 * 底部配置
 */
declare interface FooterConfig {
    /**
     * 固定底部
     * @default true
     */
    fixedFooter?: boolean;
    /**
     * 底部的高度
     * @default 48px
     */
    footerHeight?: number;
}

/**
 * 头部配置
 */
declare interface HeaderConfig {
    /**
     * 头部高度
     * @default 56px
     */
    headerHeight?: number;
}

/**
 * 布局模式
 * - horizontal 水平
 * - vertical 垂直
 */
export declare type LayoutMode = 'horizontal' | 'vertical';

/**
 * 布局组件的属性
 */
declare interface LayoutProps extends HeaderConfig, SiderConfig, ContentConfig, FooterConfig {
    /**
     * 布局模式
     * - {@link LayoutMode}
     */
    mode?: LayoutMode;
    /** 是否是移动端 */
    isMobile?: boolean;
    /** Header,Tab,Sider和Footer的zIndex取值不超过该值 */
    maxZIndex?: number;
}

/**
 * 侧边栏配置
 */
declare interface SiderConfig {
    /**
     * 侧边栏折叠状态
     * @default false
     */
    siderCollapse?: boolean;
    /**
     * 侧边栏未折叠时的宽度
     * @default 220px
     */
    siderWidth?: number;
    /**
     * 侧边栏折叠时的宽度
     * @default 64px
     */
    siderCollapsedWidth?: number;
}

export { }
